--[[
 GEM3 - TESTING OUT OF GAME
 --------------------------------------------
  Code: Kiki - Conseil des Ombres - EU
]]

--------------- INIT CALLBACKS -------------------

local function _GEM3_GUI_CB_OnVariablesLoaded(first_time_gem,first_time_realm, first_time_char,reset_by_upgrade)
  --local first_time_gem,first_time_realm, first_time_char,reset_by_upgrade = select(1,...);
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnVariablesLoaded: "..tostring(first_time_gem).." - "..tostring(first_time_realm).." - "..tostring(first_time_char).." - "..tostring(reset_by_upgrade), 0.9, 0.8, 0.10);
end


--------------- VERSION CALLBACKS -------------------

local function _GEM3_GUI_CB_OnUpgradeNeeded(new_protocol)
  DEFAULT_CHAT_FRAME:AddMessage("Your GEM version in incompatible, you must upgrade to GEM protocol vers "..new_protocol.." (see http://christophe.calmejane.free.fr/wow/gem for more details)", 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnUpgradeSuggested(new_version)
  DEFAULT_CHAT_FRAME:AddMessage("Your GEM version in old, you should upgrade to GEM vers "..new_version.." (see http://christophe.calmejane.free.fr/wow/gem for more details)", 0.9, 0.8, 0.10);
end


--------------- DEBUG CALLBACKS -------------------

GEM3_DBG_ColorCodes = {
 [GEM3_DEBUG_GLOBAL] = {1,1,1},
 [GEM3_DEBUG_PROTOCOL] = {0.5,0.5,0},
 [GEM3_DEBUG_CHANNEL] = {0,0,1.0},
 [GEM3_DEBUG_EVENTS] = {0,0.4,0},
 [GEM3_DEBUG_COMMANDS] = {1,0.5,0},
 [GEM3_DEBUG_SUBSCRIBERS] = {1,0,1},
 [GEM3_DEBUG_SORT] = {0,0.6,0.9},
 [GEM3_DEBUG_QUEUES] = {0,0.4,0.5},
 [GEM3_DEBUG_WARNING] = {1,0.1,0.1},
 [GEM3_DEBUG_TIMESTAMP] = {1,0.5,0.7},
 [GEM3_DEBUG_SYNC] = {1,0.5,0.7},
};

local function _GEM3_GUI_CB_OnDebugMode(mode)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnDebugMode: "..mode, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnDebugMessage(dbg_type,msg)
  DEFAULT_CHAT_FRAME:AddMessage(msg,GEM3_DBG_ColorCodes[dbg_type][1],GEM3_DBG_ColorCodes[dbg_type][2],GEM3_DBG_ColorCodes[dbg_type][3]);
end

local function _GEM3_GUI_CB_OnDebugInfos(bcast,cmd_queue_count)
end


--------------- CHANNELS CALLBACKS -------------------

local function _GEM3_GUI_CB_OnAddChannel(chanstruct)
  -- Debug
  if(chanstruct.saved.guild)
  then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnAddChannel: "..GUILD, 0.9, 0.8, 0.10);
  else
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnAddChannel: "..chanstruct.saved.name, 0.9, 0.8, 0.10);
  end
end

local function _GEM3_GUI_CB_OnAddChannelFailed(name,message)
  if(message == GEM3_ERR_ADD_CHANNEL_FAILED_ALREADY_EXISTS)
  then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnAddChannelFailed: Already a channel with that name, use the 'Update' button to modify channel configuration.", 0.9, 0.8, 0.10);
    return;
  end

  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnAddChannelFailed: "..name..": "..message, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnDelChannel(channel)
  -- Debug
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnDelChannel: "..channel, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnUpdateChannel(chanstruct)
  -- Debug
  if(chanstruct.saved.guild)
  then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUpdateChannel: "..GUILD, 0.9, 0.8, 0.10);
  else
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUpdateChannel: "..chanstruct.saved.name, 0.9, 0.8, 0.10);
  end
end

local function _GEM3_GUI_CB_OnUpdateChannelFailed(name,message)
  if(message == GEM3_ERR_UPDATE_CHANNEL_FAILED_GUILD_CHAN)
  then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUpdateChannelFailed: Nothing to update for special 'Guild' channel", 0.9, 0.8, 0.10);
    return;
  end

  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUpdateChannelFailed: "..name..": "..message, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnChannelsConfigLoaded()
  -- Debug
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnChannelsConfigLoaded", 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnPlayerJoinedChannel(channel,player)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnPlayerJoinedChannel: "..tostring(channel)..": "..tostring(player), 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnPlayerLeftChannel(channel,player)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnPlayerLeftChannel: "..tostring(channel)..": "..tostring(player), 0.9, 0.8, 0.10);
end


--------------- EVENT CALLBACKS -------------------

local function _GEM3_GUI_CB_OnNewEvent(event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnNewEvent: EventID="..event.id, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnNewEventLost(event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnNewEventLost: EventID="..event.id, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnEventCreated(event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnEventCreated: EventID="..event.id, 0.9, 0.8, 0.10);
  -- Now is the time to subscribe yourself (or auto-members) before the event is broadcasted
--~  GEM3_SUB_CreateSubscriber();
--~  GEMNew_CheckAutoMembers(event.id);
end

local function _GEM3_GUI_CB_OnUpdatedEvent(event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUpdatedEvent: EventID="..event.id, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnUpdatedEventLost(event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUpdatedEventLost: EventID="..event.id, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnClosedEvent(event,reason)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnClosedEvent: EventID="..event.id.." Reason="..reason, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnDeletedEvent(event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnDeletedEvent: EventID="..event.id.." ("..tostring(GEM3_QA_Events.events[event.id])..")", 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnCrashedEvent(event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnCrashedEvent: EventID="..event.id.." Place="..event.ev_place.." Date="..date("%c",event.ev_date).." LastUpdated="..date("%c",event.update_time), 0.9, 0.8, 0.10);
  GEM3_EVT_RecoverLostEvent(event);
  --GEM3_EVT_RejectLostEvent(event);
  --GEM3_EVT_DeleteLostEvent(event,"because");
end

local function _GEM3_GUI_CB_OnUpdatedRecoveredEvent(new_event,previous_event)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUpdatedRecoveredEvent: EventID="..new_event.id.." Place="..new_event.ev_place.." Date="..date("%c",new_event.ev_date).." LastUpdated="..date("%c",new_event.update_time), 0.9, 0.8, 0.10);
  --GEM3_EVT_AcceptUpdatedRecoveredEvent(new_event);
  GEM3_EVT_RejectUpdatedRecoveredEvent(new_event);
end


--------------- SUBSCRIPTION CALLBACKS -------------------

local function _GEM3_GUI_CB_OnSubscribed(ev_id,pl_name,queue)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnSubscribed: I've subscribed to EventID="..ev_id.." with character "..pl_name.." in queue "..queue, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnUnSubscribed(ev_id,pl_name,comment)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnUnSubscribed: Player "..pl_name.." unsubscribed from EventID="..ev_id.." with comment '"..tostring(comment).."'", 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnSubscriptionChanged(ev_id,pl_name,queue)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnSubscriptionChanged: My subscription changed for EventID="..ev_id.." with character "..pl_name..". I'm now in queue "..queue, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnSubscriptionLost(ev_id,pl_name)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnSubscriptionLost: Leader of EventID="..ev_id.." lost my subscription with character "..pl_name, 0.9, 0.8, 0.10);
end

local function _GEM3_GUI_CB_OnSubscriptionFailed(ev_id,pl_name,code)
  DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnSubscriptionFailed: EventID="..ev_id.." subscription failed with '"..pl_name.."': "..code, 0.9, 0.8, 0.10);
end


--------------- SUBSCRIPTION CALLBACKS -------------------

local function _GEM3_GUI_CB_OnPlayerInfosUpdate(channel,infos)
  if(channel == GEM3_GuildChannelName) -- Special guild channel
  then
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnPlayerInfosUpdate: Channel="..channel.." Player="..infos.name.." isLeader="..tostring(infos.isLeader), 0.9, 0.8, 0.10);
  else
    DEFAULT_CHAT_FRAME:AddMessage("GEM3 OnPlayerInfosUpdate: Channel="..channel.." Player="..infos.name, 0.9, 0.8, 0.10);
  end
end


--------------- INITIALIZE CALLBACKS TABLE -------------------

if(GEM3_RegisterCallback)
then
-- Init
  GEM3_RegisterCallback("OnVariablesLoaded",_GEM3_GUI_CB_OnVariablesLoaded);
-- Version
  GEM3_RegisterCallback("OnUpgradeNeeded",_GEM3_GUI_CB_OnUpgradeNeeded);
  GEM3_RegisterCallback("OnUpgradeSuggested",_GEM3_GUI_CB_OnUpgradeSuggested);
-- Debug
  GEM3_RegisterCallback("OnDebugMode",_GEM3_GUI_CB_OnDebugMode);
  GEM3_RegisterCallback("OnDebugMessage",_GEM3_GUI_CB_OnDebugMessage);
  GEM3_RegisterCallback("OnDebugInfos",_GEM3_GUI_CB_OnDebugInfos);
-- Channels
  GEM3_RegisterCallback("OnChannelsConfigLoaded",_GEM3_GUI_CB_OnChannelsConfigLoaded);
  GEM3_RegisterCallback("OnAddChannel",_GEM3_GUI_CB_OnAddChannel);
  GEM3_RegisterCallback("OnAddChannelFailed",_GEM3_GUI_CB_OnAddChannelFailed);
  GEM3_RegisterCallback("OnDelChannel",_GEM3_GUI_CB_OnDelChannel);
  GEM3_RegisterCallback("OnUpdateChannel",_GEM3_GUI_CB_OnUpdateChannel);
  GEM3_RegisterCallback("OnUpdateChannelFailed",_GEM3_GUI_CB_OnUpdateChannelFailed);
  GEM3_RegisterCallback("OnPlayerJoinedChannel",_GEM3_GUI_CB_OnPlayerJoinedChannel);
  GEM3_RegisterCallback("OnPlayerLeftChannel",_GEM3_GUI_CB_OnPlayerLeftChannel);
-- Events
  GEM3_RegisterCallback("OnNewEvent",_GEM3_GUI_CB_OnNewEvent);
  GEM3_RegisterCallback("OnNewEventLost",_GEM3_GUI_CB_OnNewEventLost);
  GEM3_RegisterCallback("OnEventCreated",_GEM3_GUI_CB_OnEventCreated);
  GEM3_RegisterCallback("OnUpdatedEvent",_GEM3_GUI_CB_OnUpdatedEvent);
  GEM3_RegisterCallback("OnUpdatedEventLost",_GEM3_GUI_CB_OnUpdatedEventLost);
  GEM3_RegisterCallback("OnClosedEvent",_GEM3_GUI_CB_OnClosedEvent);
  GEM3_RegisterCallback("OnDeletedEvent",_GEM3_GUI_CB_OnDeletedEvent);
  GEM3_RegisterCallback("OnCrashedEvent",_GEM3_GUI_CB_OnCrashedEvent);
  GEM3_RegisterCallback("OnUpdatedRecoveredEvent",_GEM3_GUI_CB_OnUpdatedRecoveredEvent);
-- Subscription
  GEM3_RegisterCallback("OnSubscribed",_GEM3_GUI_CB_OnSubscribed);
  GEM3_RegisterCallback("OnUnSubscribed",_GEM3_GUI_CB_OnUnSubscribed);
  GEM3_RegisterCallback("OnSubscriptionChanged",_GEM3_GUI_CB_OnSubscriptionChanged);
  GEM3_RegisterCallback("OnSubscriptionLost",_GEM3_GUI_CB_OnSubscriptionLost);
  GEM3_RegisterCallback("OnSubscriptionFailed",_GEM3_GUI_CB_OnSubscriptionFailed);
-- Players
  GEM3_RegisterCallback("OnPlayerInfosUpdate",_GEM3_GUI_CB_OnPlayerInfosUpdate);
else
-- Init
  GEM3_GUI_Callbacks["OnVariablesLoaded"] = _GEM3_GUI_CB_OnVariablesLoaded;
-- Version
  GEM3_GUI_Callbacks["OnUpgradeNeeded"] = _GEM3_GUI_CB_OnUpgradeNeeded;
  GEM3_GUI_Callbacks["OnUpgradeSuggested"] = _GEM3_GUI_CB_OnUpgradeSuggested;
-- Debug
  GEM3_GUI_Callbacks["OnDebugMode"] = _GEM3_GUI_CB_OnDebugMode;
  GEM3_GUI_Callbacks["OnDebugMessage"] = _GEM3_GUI_CB_OnDebugMessage;
  GEM3_GUI_Callbacks["OnDebugInfos"] = _GEM3_GUI_CB_OnDebugInfos;
-- Channels
  GEM3_GUI_Callbacks["OnChannelsConfigLoaded"] = _GEM3_GUI_CB_OnChannelsConfigLoaded;
  GEM3_GUI_Callbacks["OnAddChannel"] = _GEM3_GUI_CB_OnAddChannel;
  GEM3_GUI_Callbacks["OnAddChannelFailed"] = _GEM3_GUI_CB_OnAddChannelFailed;
  GEM3_GUI_Callbacks["OnDelChannel"] = _GEM3_GUI_CB_OnDelChannel;
  GEM3_GUI_Callbacks["OnUpdateChannel"] = _GEM3_GUI_CB_OnUpdateChannel;
  GEM3_GUI_Callbacks["OnUpdateChannelFailed"] = _GEM3_GUI_CB_OnUpdateChannelFailed;
  GEM3_GUI_Callbacks["OnPlayerJoinedChannel"] = _GEM3_GUI_CB_OnPlayerJoinedChannel;
  GEM3_GUI_Callbacks["OnPlayerLeftChannel"] = _GEM3_GUI_CB_OnPlayerLeftChannel;
-- Events
  GEM3_GUI_Callbacks["OnNewEvent"] = _GEM3_GUI_CB_OnNewEvent;
  GEM3_GUI_Callbacks["OnNewEventLost"] = _GEM3_GUI_CB_OnNewEventLost;
  GEM3_GUI_Callbacks["OnEventCreated"] = _GEM3_GUI_CB_OnEventCreated;
  GEM3_GUI_Callbacks["OnUpdatedEvent"] = _GEM3_GUI_CB_OnUpdatedEvent;
  GEM3_GUI_Callbacks["OnUpdatedEventLost"] = _GEM3_GUI_CB_OnUpdatedEventLost;
  GEM3_GUI_Callbacks["OnClosedEvent"] = _GEM3_GUI_CB_OnClosedEvent;
  GEM3_GUI_Callbacks["OnDeletedEvent"] = _GEM3_GUI_CB_OnDeletedEvent;
  GEM3_GUI_Callbacks["OnCrashedEvent"] = _GEM3_GUI_CB_OnCrashedEvent;
  GEM3_GUI_Callbacks["OnUpdatedRecoveredEvent"] = _GEM3_GUI_CB_OnUpdatedRecoveredEvent;
-- Subscription
  GEM3_GUI_Callbacks["OnSubscribed"] = _GEM3_GUI_CB_OnSubscribed;
  GEM3_GUI_Callbacks["OnUnSubscribed"] = _GEM3_GUI_CB_OnUnSubscribed;
  GEM3_GUI_Callbacks["OnSubscriptionChanged"] = _GEM3_GUI_CB_OnSubscriptionChanged;
  GEM3_GUI_Callbacks["OnSubscriptionLost"] = _GEM3_GUI_CB_OnSubscriptionLost;
  GEM3_GUI_Callbacks["OnSubscriptionFailed"] = _GEM3_GUI_CB_OnSubscriptionFailed;
-- Players
  GEM3_GUI_Callbacks["OnPlayerInfosUpdate"] = _GEM3_GUI_CB_OnPlayerInfosUpdate;
end
