--if(true) then return end
--[[
 GEM3 - TESTING OUT OF GAME
 --------------------------------------------
  Code: Kiki - Conseil des Ombres - EU
]]

-- ##########################
-- WOW NEEDED API
-- ##########################

require("wow_api")

-- Set TOC metadata & cvars
SetAddOnMetadata("GEM3_Core","Version","3.05");
SetCVar("GuildName","myguild");
SetCVar("NumGuildMembersOnline",2);
SetCVar("GuildMember_1","player");
SetCVar("GuildMember_2","guildou2");

-- Ace3
dofile("../../Ace3/LibStub/LibStub.lua")
dofile("../../Ace3/AceAddon-3.0/AceAddon-3.0.lua")
dofile("../../Ace3/CallbackHandler-1.0/CallbackHandler-1.0.lua")
dofile("../../Ace3/AceComm-3.0/ChatThrottleLib.lua")
dofile("../../Ace3/AceComm-3.0/AceComm-3.0.lua")
dofile("../../Ace3/AceSerializer-3.0/AceSerializer-3.0.lua")
dofile("../lib/CustomChatComm/CustomChatComm.lua");
-- Chronos
dofile("../lib/Chronos/localization.en.lua")
dofile("../lib/Chronos/Chronos.lua")
-- GroupAnalyse
dofile("../lib/GroupAnalyse/GroupAnalyse.lua")

-- Gem core part
dofile("../core/GEM_consts.lua");
dofile("../loc/critical_localization.lua");
dofile("../loc/localization_en.lua");
dofile("../core/GEM_debug.lua");
dofile("../core/GEM_defaults.lua");
dofile("../core/GEM_comm.lua");
dofile("../core/GEM_commands.lua");
dofile("../core/GEM_channels.lua");
dofile("../core/GEM_cmd.lua");
dofile("../core/GEM_events.lua");
dofile("../core/GEM_subscribers.lua");
dofile("../core/GEM_core.lua");
dofile("../core/GEM_players.lua");
dofile("../core/GEM_queues.lua");
dofile("../core/GEM_stamp.lua");
dofile("../core/GEM_sort_plugins.lua");
dofile("../core/GEM_sync.lua");
dofile("../plugins/sort/stamp.lua");

-- Gem fake ui part for callbacks
dofile("gem3_test_ui.lua");

-- #####################
local _sv_GEM3_Config_kiki = {};
local _qa_GEM3_QA_Config_kiki = nil;
local _qa_GEM3_QA_Channels_kiki = nil;
local _sv_GEM3_Config_loona = {};
local _qa_GEM3_QA_Config_loona = nil;
local _qa_GEM3_QA_Channels_loona = nil;
local _sv_GEM3_Events_kiki = {};
local _qa_GEM3_QA_Events_kiki = nil;
local _sv_GEM3_Events_loona = {};
local _qa_GEM3_QA_Events_loona = nil;
local function SwitchToKiki()
  SetCVar("UnitName_player","Kiki");
  SetCVar("UnitClass1_player","Shaman");
  SetCVar("UnitClass2_player","SHAMAN");
  SetCVar("UnitName_guildou2","Loona");
  SetCVar("UnitClass1_guildou2","Druid");
  GEM3_PlayerName = UnitName("player");
  print("-=## Switch to "..GEM3_PlayerName.." ##=-");

  _sv_GEM3_Config_loona = GEM3_Config;
  _qa_GEM3_QA_Config_loona = GEM3_QA_Config;
  _qa_GEM3_QA_Channels_loona = GEM3_QA_Channels;
  _sv_GEM3_Events_loona = GEM3_Events;
  _qa_GEM3_QA_Events_loona = GEM3_QA_Events;

  GEM3_Config = _sv_GEM3_Config_kiki;
  GEM3_QA_Config = _qa_GEM3_QA_Config_kiki;
  GEM3_QA_Channels = _qa_GEM3_QA_Channels_kiki;
  GEM3_Events = _sv_GEM3_Events_kiki;
  GEM3_QA_Events = _qa_GEM3_QA_Events_kiki;
end
local function SwitchToLoona()
  SetCVar("UnitName_player","Loona");
  SetCVar("UnitClass1_player","Druid");
  SetCVar("UnitClass2_player","DRUID");
  SetCVar("UnitName_guildou2","Kiki");
  SetCVar("UnitClass1_guildou2","Shaman");
  GEM3_PlayerName = UnitName("player");
  print("-=## Switch to "..GEM3_PlayerName.." ##=-");

  _sv_GEM3_Config_kiki = GEM3_Config;
  _qa_GEM3_QA_Config_kiki = GEM3_QA_Config;
  _qa_GEM3_QA_Channels_kiki = GEM3_QA_Channels;
  _sv_GEM3_Events_kiki = GEM3_Events;
  _qa_GEM3_QA_Events_kiki = GEM3_QA_Events;

  GEM3_Config = _sv_GEM3_Config_loona;
  GEM3_QA_Config = _qa_GEM3_QA_Config_loona;
  GEM3_QA_Channels = _qa_GEM3_QA_Channels_loona;
  GEM3_Events = _sv_GEM3_Events_loona;
  GEM3_QA_Events = _qa_GEM3_QA_Events_loona;

  if(GEM3_QA_Config == nil) -- First time
  then
    GEM3_QA_Config = GEM3_Config[GEM3_Realm][GEM3_PlayerName];
  end
  if(GEM3_QA_Events == nil) -- First time
  then
    GEM3_QA_Events = GEM3_Events[GEM3_Realm];
  end
  if(GEM3_QA_Channels == nil) -- First time
  then
    GEM3_QA_Channels = GEM3_QA_Config.channels;
  end
end
-- #####################

-- Fire init
SwitchToKiki();

WoWAPI_FireEvent("PLAYER_ENTERING_WORLD");
WoWAPI_FireEvent("VARIABLES_LOADED");
print("####### FIRE UPDATE 5 #######");
WoWAPI_FireUpdate(5);
print("####### FIRE UPDATE 35 #######");
WoWAPI_FireUpdate(35);
print("####### FIRE UPDATE 160 #######");
WoWAPI_FireUpdate(160);
--GEM3_QA_Config.debug_flags=0;
-- Dup init to loona
_sv_GEM3_Config_loona[GEM3_Realm] = {};
_sv_GEM3_Config_loona[GEM3_Realm]["Loona"] = DuplicateTable(GEM3_Config[GEM3_Realm]["Kiki"]);
_sv_GEM3_Events_loona[GEM3_Realm] = DuplicateTable(GEM3_Events[GEM3_Realm]);

-- ######
local _last_serialize = nil;
local _old;
local _serialize_queue = {};
local function _new_serialize(...)
  _last_serialize = _old(...);
  tinsert(_serialize_queue,_last_serialize);
  return _last_serialize;
end
_old = GEM3_Core_Addon.Serialize;
GEM3_Core_Addon.Serialize = _new_serialize;
local function EmptyChatMessageQueue(from)
  local count = #_serialize_queue;
  print("## EMPTYING QUEUE (msgs from "..from..")(#"..count..") ##");
  for i=1,count
  do
    print("## QUEUE "..i.." ##");
    WoWAPI_FireEvent("CHAT_MSG_ADDON", "GEM3_Core", _serialize_queue[1], "GUILD", from);
    tremove(_serialize_queue,1);
  end
  print("## QUEUE CLEARED ##");
end

print("\n#########################################");
print("############# INIT COMPLETE #############");
print("#########################################\n");

local clas = {};
clas["WARRIOR"] = {};
clas["PALADIN"] = {};
clas["SHAMAN"] = {};
clas["ROGUE"] = {};
clas["MAGE"] = {};
clas["WARLOCK"] = {};
clas["HUNTER"] = {};
clas["DRUID"] = {min=2};
clas["PRIEST"] = {};
local roles = {};
roles[GEM3_ROLE_TANK] = { };
roles[GEM3_ROLE_CDPS] = { max=1}; -- Close DPS
roles[GEM3_ROLE_RDPS] = { }; -- Range DPS
roles[GEM3_ROLE_DPS] = { }; -- Any DPS
roles[GEM3_ROLE_HEAL] = { };

local ev_date = 1229999500;

print("####### KIKI - CREATE NEW EVENT #######");
local ev_id,reason = GEM3_EVT_CreateNewEvent(GEM3_GuildChannelName,"Kiki",ev_date,nil,"TDM","heroic",5,70,70,DuplicateTable(clas),DuplicateTable(roles),"Date and min",GEM3_EVT_TYPE_NONE,GEM3_EVT_SUB_TYPE_NONE,0);
if(ev_id == nil)
then
  print("Create event error: "..reason);
  return;
end
local event = GEM3_QA_Events.events[ev_id];
GEM3_EVT_SetAssistant(ev_id,"Loona");

-- Loona get event
print("####### LOONA - GET NEW EVENT #######");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
print("####### ########## #######");

-- ##################### -- Test subscribe from a reroll of another channel
for i=1,5000000 do os.time() end
local result,reason = GEM3_SUB_Subscribe(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub error: "..reason);
  return;
end
SwitchToKiki();
EmptyChatMessageQueue("Loona");
--GEM3_EVT_BanFromEvent(ev_id,"Loona","Because");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
--[[local result,reason = GEM3_SUB_Subscribe(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub error: "..reason);
  return;
end
SwitchToKiki();
EmptyChatMessageQueue("Loona");]]
if(true) then return end
-- #####################

-- ##################### -- Test custom message
--[[local function my_custom_cb_msg(channel,from,stamp,...)
  print("Message from: "..from.." on channel "..channel.." at "..stamp);
  local a,b,c = select(1,...);
  print(type(a)..": "..tostring(a));
  print(type(b)..": "..tostring(b));
  print(type(c)..": "..tostring(c));
end

local function my_custom_cb_cmd(channel,from,stamp,ev_id,...)
  print("Command from: "..from.." on channel "..channel.." at "..stamp.." for EventID "..ev_id);
  local a,b,c = select(1,...);
  print(type(a)..": "..tostring(a));
  print(type(b)..": "..tostring(b));
  print(type(c)..": "..tostring(c));
end

print("####### TEST CUSTOM MESSAGE #######");
if(GEM3_COM_RegisterCustomMessage("my_custom_msg",my_custom_cb_msg) == false)
then
  print("Failed to register custom message");
  return;
end
if(GEM3_COM_SendCustomMessage(GEM3_GuildChannelName,"my_custom_msg","salut",1,{}) == false)
then
  print("Failed to send custom message");
  return;
end
if(GEM3_COM_RegisterCustomCommand("my_custom_cmd",my_custom_cb_cmd) == false)
then
  print("Failed to register custom command");
  return;
end
if(GEM3_COM_SendCustomCommand(GEM3_GuildChannelName,"my_custom_cmd",ev_id,"Kiki","pouet",3) == false)
then
  print("Failed to send custom command");
  return;
end
SwitchToKiki();
EmptyChatMessageQueue("Loona");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
if(true) then return end]]
-- #####################

-- ##################### -- Simulate Lead-Force queue
--[[print("####### TEST FORCE QUEUE #######");
local result,reason = GEM3_SUB_Subscribe(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Failed to subscribe: "..reason);
  return;
end
SwitchToKiki();
EmptyChatMessageQueue("Loona");
for i=1,5000000 do os.time() end
GEM3_SUB_ForceQueueForPlayer(ev_id,"Loona",GEM3_SUB_FORCE_QUEUE_REPLACEMENT);
print("####### FIRE UPDATE 175 #######");
WoWAPI_FireUpdate(175);
SwitchToLoona();
print(GEM3_SUB_GetSubscribedInfos(ev_id).state)
EmptyChatMessageQueue("Kiki");
print(GEM3_SUB_GetSubscribedInfos(ev_id).state)
if(true) then return end]]
-- #####################

-- ##################### -- Simulate Event edition with level range kicking
--[[print("####### TEST LEVEL KICKING #######");
local result,reason = GEM3_SUB_Subscribe(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Failed to subscribe: "..reason);
  return;
end
SwitchToKiki();
EmptyChatMessageQueue("Loona");
-- Edit event
GEM3_EVT_ModifyEvent(event,ev_date,nil,"TDM","heroic",5,69,69,DuplicateTable(clas),DuplicateTable(roles),"Date and min",GEM3_EVT_TYPE_NONE,GEM3_EVT_SUB_TYPE_NONE,0);
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
if(true) then return end]]
-- #####################

-- ##################### -- Simulate GEM3_SUB_SubscribeExternal
--[[print("####### TEST GEM3_SUB_SubscribeExternal #######");
local result,reason = GEM3_SUB_SubscribeExternal(ev_id,"Kiki","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Failed to subscribe: "..reason);
  return;
end
print("####### FIRE UPDATE 165 #######");
WoWAPI_FireUpdate(165);
SwitchToKiki();
EmptyChatMessageQueue("Loona");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
for i=1,5000000 do os.time() end
local result,reason = GEM3_SUB_SubscribeExternal(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NOT_COMING,GEM3_ROLE_UNKNOWN);
print("####### FIRE UPDATE 175 #######");
WoWAPI_FireUpdate(175);
SwitchToKiki();
EmptyChatMessageQueue("Loona");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
if(true) then return end]]
-- #####################

-- ######################## Simulate queue sorting
--[[local result,reason = GEM3_SUB_Subscribe(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub error: "..reason);
  return;
end
for i=1,5000000 do os.time() end
local result,reason = GEM3_SUB_SubscribeExternal(ev_id,"Midona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub2 error: "..reason);
  return;
end
SwitchToKiki();
EmptyChatMessageQueue("Loona");
--for i=1,5000000 do os.time() end
GEM3_SUB_ForceQueueForPlayer(ev_id,"Midona",GEM3_SUB_FORCE_QUEUE_TITULAR);
local result,reason = GEM3_SUB_Subscribe(ev_id,"Kiki","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub3 error: "..reason);
  return;
end
if(true) then return end]]
-- ######################## 

-- ######################## Simulate lead change his subscription
--[[SwitchToKiki();
EmptyChatMessageQueue("Loona");
local result,reason = GEM3_SUB_Subscribe(ev_id,"Kiki","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub error: "..reason);
  return;
end
print("--------> "..tostring(GEM3_QA_Events.events[ev_id].players["Kiki"].current_queue));
EmptyChatMessageQueue("Kiki");
for i=1,10000000 do os.time() end -- Wait a little
local result,reason = GEM3_SUB_SubscribeUpdate(ev_id,"Kiki","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NOT_COMING,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("ReSub error: "..reason);
  return;
end
EmptyChatMessageQueue("Kiki");
print("--------> "..tostring(GEM3_QA_Events.events[ev_id].players["Kiki"].current_queue));
if(true) then return end]]
-- ######################## 

-- ######################## Simulate event deletion
--[[SwitchToKiki();
EmptyChatMessageQueue("Loona");
GEM3_EVT_CloseEvent(ev_id,"");
for i=1,10000000 do os.time() end -- Wait a little
GEM3_EVT_DeleteEvent(ev_id);
--EmptyChatMessageQueue("Kiki");
--SwitchToLoona();
--GEM3_COM_BroadcastEvent(GEM3_QA_Events.events[ev_id]);
--SwitchToKiki();
--EmptyChatMessageQueue("Loona");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
if(true) then return end]]
-- ######################## 

-- ########################  -- Simulate data lost
--[[SwitchToKiki();
EmptyChatMessageQueue("Loona");
    local newrealm = {};
    newrealm.events = {};
    newrealm.commands = {};
    newrealm.my_deleted_events = {};
    newrealm.ignored = {};
    newrealm.subscribed = {};
    newrealm.kicked = {};
    newrealm.banned = {};
    newrealm.ignored_players = {};
    newrealm.forward = {};
    newrealm.archived = {};
    newrealm.assistants = {};
    GEM3_Events[GEM3_Realm] = newrealm;
    GEM3_QA_Events = GEM3_Events[GEM3_Realm];

print("####### LOONA #######");
for i=1,10000000 do os.time() end -- Wait a little
SwitchToLoona();
GEM3_COM_BroadcastEvent(GEM3_QA_Events.events[ev_id]);
print("####### KIKI - RECOVER #######");
for i=1,10000000 do os.time() end -- Wait a little
SwitchToKiki();
EmptyChatMessageQueue("Loona");

print("####### LOONA #######");
SwitchToLoona();
for i=1,10000000 do os.time() end -- Wait a little
GEM3_QA_Events.events[ev_id].update_time = GEM3_QA_Events.events[ev_id].update_time + 1;
EmptyChatMessageQueue("Kiki");
print("####### FIRE UPDATE 500 - FORCE EVENT BCAST #######");
WoWAPI_FireUpdate(500);
GEM3_COM_BroadcastEvent(GEM3_QA_Events.events[ev_id]);

print("####### KIKI - UPDT RECOVER #######");
for i=1,10000000 do os.time() end -- Wait a little
SwitchToKiki();
EmptyChatMessageQueue("Loona");
print("####### LOONA FLUSH #######");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");

--for i=1,5000000 do os.time() end -- Wait a little
if(true) then return end]]
-- ########################

-- ##################### -- Simulate ImportedCommands
--[[print("####### TEST IMPORTED COMMANDS #######");
local result,reason = GEM3_SUB_Subscribe(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
SwitchToKiki();
EmptyChatMessageQueue("Loona");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");
GEM3_ExternalCommands[1] = { protocol=GEM3_COM_PROTOCOL_REVISION, cmd="Subscribe", channel="guild-myguild", ev_id=ev_id, leader="Kiki", ev_date=ev_date, pl_name="Loona", guild="my guild", level=70, class="DRUID", role=2, comment="", queue=0, stamp=GEM3_STAMP_GetLocalStamp()};
GEM3_SYNC_CheckForExternalCommands();
SwitchToKiki();
EmptyChatMessageQueue("Loona");
if(true) then return end]]
-- #####################

-- Loona subscribing
print("####### LOONA - SUBSCRIBING #######");
local result,reason = GEM3_SUB_Subscribe(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub error: "..reason);
  return;
end
print("STATE: "..GEM3_SUB_GetSubscribedInfos(ev_id).state);
for i=1,5000000 do os.time() end -- Wait a little
local result,reason = GEM3_SUB_SubscribeUpdate(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"test minor update",GEM3_SUB_FORCE_QUEUE_NONE,GEM3_ROLE_UNKNOWN);
if(not result)
then
  print("Sub2 error: "..reason);
  if(reason == GEM3_LOC_SUB_SUBSCRIBE_PENDING)
  then
    print("Re sending subscription");
    result,reason = GEM3_SUB_ResendSubscription(ev_id,pl_name);
    if(not result)
    then
      print("Resend error: "..reason);
      return;
    end
  else
    return;
  end
end
print("STATE: "..GEM3_SUB_GetSubscribedInfos(ev_id).state);


print("####### KIKI - GET SUBSCRIPTION #######");
for i=1,5000000 do os.time() end -- Wait a little to have a new update_time for event
SwitchToKiki();
EmptyChatMessageQueue("Loona");
print("####### FIRE UPDATE 200 - FORCE EVENT BCAST #######");
WoWAPI_FireUpdate(200);

print("####### LOONA - GET SUB ACK AND EVENT UPDT #######");
SwitchToLoona();
print("STATE: "..GEM3_SUB_GetSubscribedInfos(ev_id).state);
EmptyChatMessageQueue("Kiki"); -- Comment this to force 'GEM3_SUB_IsLatestSubscriptionReceived' to return false
print("STATE: "..GEM3_SUB_GetSubscribedInfos(ev_id).state);

print("####### LOONA - UNSUBSCRIBING #######");
for i=1,5000000 do os.time() end
local result,reason = GEM3_SUB_SubscribeUpdate(ev_id,"Loona","my guild",70,"DRUID",GEM3_ROLE_CDPS,"",GEM3_SUB_FORCE_QUEUE_NOT_COMING,GEM3_ROLE_UNKNOWN);
if(not result)
then
  if(reason == GEM3_LOC_SUB_SUBSCRIBE_UPDATE_SAME and not GEM3_SUB_IsLatestSubscriptionReceived(ev_id,"Loona")) -- Same data, but not acked
  then
    if(true) -- <- leader online test
    then
      print("Humm leader is online, but lost my sub. Resending");
      GEM3_SUB_ResendSubscription(ev_id,"Loona");
      return;
    end
  end
  print("Sub update error: "..reason);
  return;
end

if(true) then return end

print("####### KIKI - GET RESUBSCRIBING #######");
SwitchToKiki();
EmptyChatMessageQueue("Loona");
print("####### FIRE UPDATE 300 - FORCE EVENT BCAST #######");
WoWAPI_FireUpdate(300);

print("####### LOONA - GET RESUB ACK #######");
SwitchToLoona();
EmptyChatMessageQueue("Kiki");

